// inicializao do editor
var bLoad=false
var pureText=true
var bodyTag="<BODY MONOSPACE STYLE=\"font:10pt arial,sans-serif\">"
var bTextMode=false
public_description=new Editor

// construtor do editor avanado
function Editor() {
  this.put_html=SetHtml;
  this.get_html=GetHtml;
  this.put_text=SetText;
  this.get_text=GetText;
  this.CompFocus=GetCompFocus;
}

// requisita foco para a composio
function GetCompFocus() {
  Composition.focus();
}

// retorna o contedo de texto do iframe
function GetText() {
  return Composition.document.body.innerText;
}

// atribui um contedo de texto ao iframe da composio
function SetText(text) {
  Composition.document.body.innerHTML=text;
}

// retorna o contedo HTML do iframe
function GetHtml() {
  if (bTextMode)
    return Composition.document.body.innerText;
  else {
    cleanHtml();
    cleanHtml();
    return Composition.document.body.innerHTML;
  }
}

// atribui um contedo ao iframe da composio
function SetHtml(sVal) {
  if (bTextMode) Composition.document.body.innerText=sVal;
  else Composition.document.body.innerHTML=sVal;
}

// checa se a barra de ferramentas foi solicitada no modo de edio avanado
function validateMode() {
  if (! bTextMode) return true;
  alert("Para utilizar as ferramentas do editor avanado, desmarque a caixa 'Edio Avanada'");
  Composition.focus();
  return false;
}

// formata o texto no iframe da composio
function format(what,opt) {
  if (!validateMode()) return;
  if (opt=="removeFormat") {
    what=opt;
    opt=null;
  }
  if (opt==null) Composition.document.execCommand(what);
  else Composition.document.execCommand(what,"",opt);
  pureText = false;
  Composition.focus();
}

// alterna entre modo texto e modo HTML
function setMode(newMode) {
  bTextMode = newMode;
  var cont;
  if (bTextMode) {
    cleanHtml();
    cleanHtml();
    cont=Composition.document.body.innerHTML;
    Composition.document.body.innerText=cont;
  } else {
    cont=Composition.document.body.innerText;
    Composition.document.body.innerHTML=cont;
  }
  Composition.focus();
}

// procura e retorna um elemento
function getEl(sTag,start) {
  while ((start!=null) && (start.tagName!=sTag)) start = start.parentElement;
  return start;
}

// cria ou edita um link
function createLink()
{
  Composition.focus();
  if (!validateMode()) return;
  var isA = getEl("A",Composition.document.selection.createRange().parentElement());
  var str=prompt("Digite o endereo do link (por exemplo: http://www.domnio.com.br):", isA ? isA.href : "http:\/\/");
  if ((str!=null) && (str!="http://")) {
    if (Composition.document.selection.type=="None") {
      var sel=Composition.document.selection.createRange();
      sel.pasteHTML("<A HREF=\""+str+"\">"+str+"</A> ");
      sel.select();
    }
    else format("CreateLink",str);
  }
  else Composition.focus();
}

// cria ou edita uma imagem
function createImage() {
  Composition.focus();
  if (!validateMode()) return;
  var r = null;
  var isImg = null;
  if (Composition.document.selection.type == "Control") {
    r = Composition.document.selection.createRange();
    isImg = r(0);
  }
  else {
    var isImg = null;
  }
  var str=prompt("Digite o caminho da imagem:", isImg ? isImg.src : "http:\/\/");

  if ((str!=null) && (str!="http://")) {
    if (Composition.document.selection.type=="None") {
      var sel=Composition.document.selection.createRange();
      sel.pasteHTML("<IMG SRC=\""+str+"\" BORDER='0'>");
      sel.select();
    }
    else if (Composition.document.selection.type=="Control") {
      Composition.document.selection.createRange()(0).src = str;
    }
    else {
      format("CreateImage",str);
    }
  }
  else Composition.focus();
}

// seta a cor do texto
function foreColor() {
  var p = 0;
  if (! validateMode()) return;
  p = labelStyle.indexOf('=');
  var tstyle = labelStyle.substr(p+1);
  p = buttonStyle.indexOf('=');
  var bstyle = buttonStyle.substr(p+1);
  var arr = showModalDialog("color_selection.php?textStyle="+tstyle+"&buttonStyle="+bstyle, "", "font-family:Verdana; font-size:12; dialogWidth:32em; dialogHeight:28em");
  if (arr != null) format('forecolor', arr);
  else Composition.focus();
}

// seta a cor de fundo do texto
function backColor() {
  if (!validateMode()) return;
  p = labelStyle.indexOf('=');
  var tstyle = labelStyle.substr(p+1);
  p = buttonStyle.indexOf('=');
  var bstyle = buttonStyle.substr(p+1);
  var arr = showModalDialog("color_selection.php?textStyle="+tstyle+"&buttonStyle="+bstyle, "", "font-family:Verdana; font-size:12; dialogWidth:32em; dialogHeight:28em");
  if (arr != null) format('backcolor', arr);
  else Composition.focus()
}

// corrige falhas no HTML da composio
function cleanHtml() {
  var fonts = Composition.document.body.all.tags("FONT");
  var curr;
  for (var i = fonts.length - 1; i >= 0; i--) {
    curr = fonts[i];
    if (curr.style.backgroundColor == "#ffffff") curr.outerHTML = curr.innerHTML;
  }
}

// retorna o contedo interno das tags de pargrafo
function getPureHtml() {
  var str = "";
  var paras = Composition.document.body.all.tags("P");
  if (paras.length > 0) {
    for (var i=paras.length-1; i >= 0; i--) str = paras[i].innerHTML + "\n" + str;
  } else {
    str = Composition.document.body.innerHTML;
  }
  return str;
}

// adiciona uma caricatura  composio
function addEmoticon(emotion) {
   Composition.focus();
   var emotionImg = "<IMG SRC='"+emotion+"'>";
   var range = Composition.document.selection.createRange();
   range.pasteHTML(emotionImg);
   Smileys.style.visibility="hidden";
}