//-----------------------------------------------------------------
// @function      chkMaskCPFCNPJ
// @desc          Aplica mscara de CPF/CNPJ automaticamente
// @param         field          campo de um formulrio
// @param         event          evento do teclado
// @returns       true | false
//-----------------------------------------------------------------
function chkMaskCPFCNPJ(field,event) {
     var ns = ((document.layers || document.getElementById) && (!document.all));
     var ie = document.all;
     var keySet = '0123456789';
     var actionSet = '0,8,13';
     var keyCode = (ie) ? window.event.keyCode : event.which;
     var key = String.fromCharCode(keyCode);
     if ((keySet.indexOf(key) == -1) && (actionSet.indexOf(keyCode) == -1)) {
         return false;
     }
     else {
         return true;
     }
}

//---------------------------------------------------------------
// @function        chkCPFCNPJ
// @desc            verifica se um CPF/CNPJ  vlido
// @param           field    campo CPF/CNPJ a ser verificado
// @returns         true | false
//---------------------------------------------------------------
function chkCPFCNPJ(field)
{
    if (field.value.length == 0) {
         return true;
         
    } else if (field.value.length == 14) {
         soma1 = (field.value.charAt(0) * 5) +
                 (field.value.charAt(1) * 4) +
                 (field.value.charAt(2) * 3) +
                 (field.value.charAt(3) * 2) +
                 (field.value.charAt(4) * 9) +
                 (field.value.charAt(5) * 8) +
                 (field.value.charAt(6) * 7) +
                 (field.value.charAt(7) * 6) +
                 (field.value.charAt(8) * 5) +
                 (field.value.charAt(9) * 4) +
                 (field.value.charAt(10) * 3) +
                 (field.value.charAt(11) * 2);
         resto = soma1 % 11;
         digito1 = resto < 2 ? 0 : 11 - resto;
         soma2 = (field.value.charAt(0) * 6) +
                 (field.value.charAt(1) * 5) +
                 (field.value.charAt(2) * 4) +
                 (field.value.charAt(3) * 3) +
                 (field.value.charAt(4) * 2) +
                 (field.value.charAt(5) * 9) +
                 (field.value.charAt(6) * 8) +
                 (field.value.charAt(7) * 7) +
                 (field.value.charAt(8) * 6) +
                 (field.value.charAt(9) * 5) +
                 (field.value.charAt(10) * 4) +
                 (field.value.charAt(11) * 3) +
                 (field.value.charAt(12) * 2);
         resto = soma2 % 11;
         digito2 = resto < 2 ? 0 : 11 - resto;
         return ((field.value.charAt(12) == digito1) && (field.value.charAt(13) == digito2));

    } else if (field.value.length == 11) {
         soma1 = (field.value.charAt(0) * 10) +
                 (field.value.charAt(1) * 9) +
                 (field.value.charAt(2) * 8) +
                 (field.value.charAt(3) * 7) +
                 (field.value.charAt(4) * 6) +
                 (field.value.charAt(5) * 5) +
                 (field.value.charAt(6) * 4) +
                 (field.value.charAt(7) * 3) +
                 (field.value.charAt(8) * 2);
         resto = soma1 % 11;
         digito1 = resto < 2 ? 0 : 11 - resto;
         soma2 = (field.value.charAt(0) * 11) +
                 (field.value.charAt(1) * 10) +
                 (field.value.charAt(2) * 9) +
                 (field.value.charAt(3) * 8) +
                 (field.value.charAt(4) * 7) +
                 (field.value.charAt(5) * 6) +
                 (field.value.charAt(6) * 5) +
                 (field.value.charAt(7) * 4) +
                 (field.value.charAt(8) * 3) +
                 (field.value.charAt(9) * 2);
         resto = soma2 % 11;
         digito2 = resto < 2 ? 0 : 11 - resto;
         return ((field.value.charAt(9) == digito1) && (field.value.charAt(10) == digito2));

    } else {
         return false;
    }
}