var e_pre;
var e_add;
var e_rem;
var e_cnt;

//------------------------------------------------------------------
// @function    initEditSelection
// @desc        inicializa o contador de elementos inseridos
//              e das variveis de controle de elementos
// @param       formName        nome do formulrio
// @param       trgField        nome da listbox de destino
// @param       addedfield      nome do hidden de valores inseridos
// @param       removedfield    nome do hidden de valores removidos
//------------------------------------------------------------------
function initEditSelection(formName,trgField,addedfield,removedfield) {
   var trg = editGetElement("document."+formName+"."+trgField);
   e_cnt = editGetElement("document."+formName+".editinserted");
   e_cnt.value = trg.options.length-1;
   e_add = editGetElement("document."+formName+"."+addedfield);
   e_rem = editGetElement("document."+formName+"."+removedfield);
   e_pre = "";
   return true;
   for (var i=1; i<trg.options.length; i++) {
     if (e_pre.length > 0) {
       e_pre = e_pre + "#" + trg.options[i].value;
     }
     else {
       e_pre = trg.options[i].value;
     }
   }
}

//-------------------------------------------------------
// @function   editAdd
// @desc       copia o elemento fornecido no editfield
//             de origem para a listbox de destino
// @param      formName       nome do formulrio
// @param      source         nome do edit de origem
// @param      target         nome da listbox de destino
// @returns    true | false
//-------------------------------------------------------
function editAdd(formName,source,target) {
  var src = editGetElement("document."+formName+"."+source);
  var trg = editGetElement("document."+formName+"."+target);
  if (!src || !trg) {
    return false;
  }
  else {
    if (!isEmpty(formName,source)) {
      if ((!_editFind(e_add,src.value)) && (!_editFindPre(src.value))) {
        trg.options[trg.options.length] = new Option(src.value,src.value);
        _editAddMark(src.value);
        e_cnt.value = parseInt(e_cnt.value) + 1;
      }
      else {
        alert("Este valor j foi inserido!");
        src.focus();
      }
    }
    return true;
  }
}

//-----------------------------------------------------------------
// @function   editRemove
// @desc       remove os elementos selecionados da listbox destino
// @param      formName      nome do formulrio
// @param      target        nome da listbox de destino
// @returns    true | false
//-----------------------------------------------------------------
function editRemove(formName,target) {
  var trg = editGetElement("document."+formName+"."+target);
  var del = 0;
  if (!trg) {
    return false;
  }
  else {
    var cont = 0;
    for (var z=0; z<trg.length;z++) {
      if ((trg.options[z].selected == true) && (trg.options[z].value != "-1")) {
        if (trg.length > 1) {
          var i = z;
          var j = z;
          while ((i<=trg.length-2)&&(trg.options[i].selected == true)) {
            _editRemoveMark(trg.options[i].value);
            del++;
            cont++;
            i++;
          }
          if (cont > 0) {
            for (i=j;i<trg.length-cont;i++) {
              trg.options[i].value = trg.options[i+cont].value;
              trg.options[i].text = trg.options[i+cont].text;
              trg.options[i].selected = trg.options[i+cont].selected;
            }
            trg.length = trg.length-cont;
          }
          cont = 0;
        }
      }
    }
    if ((trg.options[trg.length-1].selected == true)&&(trg.options[trg.length-1].value != -1))
    {
      del++;
      _editRemoveMark(trg.options[trg.length-1].value);
      trg.options[trg.length-1].value = -1;
      trg.options[trg.length-1].text = "                          ";
      if ((trg.length) > 1) {
        trg.length--;
      }
    }
    e_cnt.value = e_cnt.value - del;
  }
}

//------------------------------------------------------------
// @function     editRemoveAll
// @desc         remove todos os elementos da listbox destino
// @param        formName     nome do formulrio
// @param        target       nome da listbox de destino
// @returns      true | false
//------------------------------------------------------------
function editRemoveAll(formName,target) {
   var trg = editGetElement("document."+formName+"."+target);
   var del = 0;
   if (!trg) {
     return false;
   }
   else {
     if (trg.options.length > 100) {
        alert("Voc solicitou a remoo total dos registros da caixa de seleo de destino.\nEsta operao poder demorar alguns segundos.");
     }
     for (var i=1; i<trg.options.length; i++) {
        _editRemoveMark(trg.options[i].value);
        del++;
     }
     trg.options.length = 1;
     e_cnt.value = e_cnt.value - del;
     return true;
   }
}

//----------------------------------------------------------------------
// @function     editGetElement
// @desc         retorna um objeto do formulrio a partir do
//               seu caminho na rvore de objetos (document.form.field)
// @param        str       caminho do objeto
// @returns      objeto correspondente ao caminho indicado | undefined
//----------------------------------------------------------------------
function editGetElement(str) {
   return eval(str);
}

//----------------------------------------------------------------
// @function     _editAddMark
// @desc         registra a insero de um elemento se necessrio
// @param        optValue   valor inserido
//----------------------------------------------------------------
function _editAddMark(optValue) {
   if (_editFind(e_rem,optValue)) {
     var pos = e_rem.value.indexOf(optValue);
     e_rem.value = e_rem.value.substr(0,pos-1)+e_rem.value.substr(pos+optValue.length);
   }
   else {
     if (e_add.value.length > 0) {
        e_add.value = e_add.value + "#" + optValue;
     }
     else {
        e_add.value = optValue;
     }
   }
}

//---------------------------------------------------------------
// @function     _editRemoveMark
// @desc         registra a remoo de um elemento se necessrio
// @param        optValue   valor removido
//---------------------------------------------------------------
function _editRemoveMark(optValue) {
   var in_add = _editFind(e_add,optValue);
   var in_pre = _editFindPre(optValue);
   if ((in_add) && (!in_pre)) {
     var pos = e_add.value.indexOf(optValue);
     e_add.value = e_add.value.substr(0,pos-1)+e_add.value.substr(pos+optValue.length+1);
   }
   else {
     if (e_rem.value.length > 0) {
       e_rem.value = e_rem.value + "#" + optValue;
     }
     else {
       e_rem.value = optValue;
     }
   }
}

//----------------------------------------------------------
// @function     _editFind
// @desc         procura por um elemento em um campo string
// @param        field       campo a ser pesquisado
// @param        value       valor a ser procurado no campo
// @returns      true | false
//----------------------------------------------------------
function _editFind(field,value) {
   var values = field.value.split('#');
   for (var i=0; i<values.length; i++) {
     if (values[i] == value) {
       return true;
     }
     else {
       return false;
     }
   }
}

//----------------------------------------------------------
// @function     _editFindPre
// @desc         procura por um elemento nos valores
//               pr-inseridos (vindos do banco de dados)
// @param        value       valor a ser procurado no campo
// @returns      true | false
//----------------------------------------------------------
function _editFindPre(value) {
   var values = e_pre.split('#');
   for (var i=0; i<values.length; i++) {
     if (values[i] == value) {
       return true;
     }
     else {
       return false;
     }
   }
}