//---------------------------------------------------------------------
// @function        isEmpty
// @desc            verifica se um campo est vazio ou no selecionado
// @param           form     nome do formulrio
// @param           field    nome do campo
// @returns         true | false
//---------------------------------------------------------------------
function isEmpty(form,field) {
     var obj = getObject(form,field);
     if (!obj) {
          return false;
     } else {
          // tratamento diferenciado para o radio button
          if (!obj.type && obj.length) {
              return isRadioSelected(form,field);
          }
          else {
              switch(obj.type) {
                     case "text"            :
                     case "password"        :
                     case "textarea"        : return (trim(obj) == ""); break;
                     case "select-one"      :
                     case "select-multiple" : return isListSelected(form,field); break;
                     case "radio"           : return isRadioSelected(form,field); break;
              }
          }
     }
}

//------------------------------------------------------------
// @function   requestFocus
// @desc       requisita foco para um campo de um formulrio
// @param      form      nome do formulrio
// @param      field     nome do campo requisitando foco
//------------------------------------------------------------
function requestFocus(form,field) {
     var obj = getObject(form,field);
     if (obj) {
          switch(obj.type) {
                 case "text"            :
                 case "password"        :
                 case "textarea"        :
                 case "select-one"      :
                 case "select-multiple" : obj.focus(); break;
                 case "radio"           : break;
          }
     }
}

//------------------------------------------------------------------
// @function      isListSelected
// @desc          verifica se foi selecionado um valor em uma lista
// @param         form     nome do formulrio
// @param         field    nome do campo listbox
// @returns       true | false
//------------------------------------------------------------------
function isListSelected(form,field) {
     var listBox = eval("document."+form+".elements['"+field+"']");
     for (i=0;i<listBox.options.length;i++) {
       if ((listBox.options[i].selected == true) && (listBox.options[i].value != ""))
         return false;
     }
     return true;
}

//--------------------------------------------------------------------
// @function      isRadioSelected
// @desc          verifica se foi selecionado um valor do radio group
// @param         form     nome do formulrio
// @param         field    nome do campo radio button
// @returns       true | false
//--------------------------------------------------------------------
function isRadioSelected(form,field) {
     var radioButton = eval("document."+form+"."+field);
     for (i=0;i<radioButton.length;i++) {
         if (radioButton[i].checked == true) return false;
     }
     return true;
}

//---------------------------------------------------
// @function      getObject
// @desc          retorna um objeto a partir do nome
//                do formulrio e do nome do campo
// @param         form     nome do formulrio
// @param         field    nome do campo
// @returns       elemento encontrado
//---------------------------------------------------
function getObject(form,field) {
     return eval("document."+form+".elements['"+field+"']");
}

//-----------------------------------------------------------
// @function      trim
// @desc          elimina espaos em branco duplos,
//                 esquerda e  direita do campo
// @param         field      campo de um formulrio
// @returns       valor sem espaos em branco desnecessrios
//-----------------------------------------------------------
function trim(field) {
     var pos = field.value.indexOf("  ");
     while (pos != -1) {
         field.value = field.value.replace("  "," ");
         pos = field.value.indexOf("  ");
     }
     field.value = (field.value.charAt(0) == ' ') ? field.value.substr(1,field.value.length-1) : field.value;
     field.value = (field.value.charAt(field.value.length-1) == ' ') ? field.value.substr(0,field.value.length-1) : field.value;
     return field.value;
}