var s_pre;
var s_add;
var s_rem;
var s_cnt;

//------------------------------------------------------------------
// @function    initLookupSelection
// @desc        inicializa o contador de elementos inseridos
//              e das variveis de controle de elementos
// @param       formName        nome do formulrio
// @param       trgField        nome da listbox de destino
// @param       addedfield      nome do hidden de valores inseridos
// @param       removedfield    nome do hidden de valores removidos
//------------------------------------------------------------------
function initLookupSelection(formName,trgField,addedfield,removedfield) {
   var trg = selGetElement("document."+formName+"."+trgField);
   s_cnt = selGetElement("document."+formName+".selinserted");
   s_cnt.value = trg.options.length-1;
   s_add = selGetElement("document."+formName+"."+addedfield);
   s_rem = selGetElement("document."+formName+"."+removedfield);
   s_pre = "";
   for (var i=1; i<trg.options.length; i++) {
     if (s_pre.length > 0) {
       s_pre = s_pre + "#" + trg.options[i].value;
     }
     else {
       s_pre = trg.options[i].value;
     }
   }
}

//--------------------------------------------------------
// @function   selectAdd
// @desc       copia os elementos selecionados na listbox
//             de origem para a listbox de destino
// @param      formName       nome do formulrio
// @param      source         nome da listbox de origem
// @param      target         nome da listbox de destino
// @returns    true | false
//--------------------------------------------------------
function selectAdd(formName,source,target) {
  var src = selGetElement("document."+formName+"."+source);
  var trg = selGetElement("document."+formName+"."+target);
  var ins = 0;
  if (!src || !trg) {
    return false;
  }
  else {
    for (var i=0; i<src.options.length; i++) {
      if (src.options[i].selected == true) {
        if ((!_selFind(s_add,src.options[i].value)) && (!_selFindPre(src.options[i].value))) {
          trg.options[trg.options.length] = new Option(String(src.options[i].text),src.options[i].value);
          _selAddMark(src.options[i].value);
          ins++;
        }
      }
    }
    s_cnt.value = parseInt(s_cnt.value) + ins;
    return true;
  }
}

//------------------------------------------------------------
// @function    selectAddAll
// @desc        copia todos os elementos da listbox de origem
//              para a listbox de destino
// @param       formName       nome do formulrio
// @param       source         nome da listbox de origem
// @param       target         nome da listbox de destino
// @returns     true | false
//------------------------------------------------------------
function selectAddAll(formName,source,target) {
  var src = selGetElement("document."+formName+"."+source);
  var ins = 0;
  if (!src) {
    return false;
  }
  else {
    if (src.options.length > 100) {
      alert("Voc solicitou a seleo de todos os registros disponveis na caixa de seleo de origem.\nEsta operao poder demorar alguns segundos.");
    }
    for (var i=0; i<src.options.length; i++) {
      if (!_selFind(s_add,src.options[i].value)) {
        src.options[i].selected = true;
      }
    }
    selectAdd(formName,source,target);
    return true;
  }
}

//-----------------------------------------------------------------
// @function   selectRemove
// @desc       remove os elementos selecionados da listbox destino
// @param      formName      nome do formulrio
// @param      target        nome da listbox de destino
// @returns    true | false
//-----------------------------------------------------------------
function selectRemove(formName,target) {
  var trg = selGetElement("document."+formName+"."+target);
  var del = 0;
  if (!trg) {
    return false;
  }
  else {
    var cont = 0;
    for (var z=0; z<trg.length;z++) {
      if ((trg.options[z].selected == true) && (trg.options[z].value != "-1")) {
        if (trg.length > 1) {
          var i = z;
          var j = z;
          while ((i<=trg.length-2)&&(trg.options[i].selected == true)) {
            _selRemoveMark(trg.options[i].value);
            del++;
            cont++;
            i++;
          }
          if (cont > 0) {
            for (i=j;i<trg.length-cont;i++) {
              trg.options[i].value = trg.options[i+cont].value;
              trg.options[i].text = trg.options[i+cont].text;
              trg.options[i].selected = trg.options[i+cont].selected;
            }
            trg.length = trg.length-cont;
          }
          cont = 0;
        }
      }
    }
    if ((trg.options[trg.length-1].selected == true)&&(trg.options[trg.length-1].value != -1))
    {
      del++;
      _selRemoveMark(trg.options[trg.length-1].value);
      trg.options[trg.length-1].value = -1;
      trg.options[trg.length-1].text = "                          ";
      if ((trg.length) > 1) {
        trg.length--;
      }
    }
    s_cnt.value = s_cnt.value - del;
  }
}

//------------------------------------------------------------
// @function     selectRemoveAll
// @desc         remove todos os elementos da listbox destino
// @param        formName     nome do formulrio
// @param        target       nome da listbox de destino
// @returns      true | false
//------------------------------------------------------------
function selectRemoveAll(formName,target) {
   var trg = selGetElement("document."+formName+"."+target);
   var del = 0;
   if (!trg) {
     return false;
   }
   else {
     if (trg.options.length > 100) {
        alert("Voc solicitou a remoo total dos registros da caixa de seleo de destino.\nEsta operao poder demorar alguns segundos.");
     }
     for (var i=1; i<trg.options.length; i++) {
        _selRemoveMark(trg.options[i].value);
        del++;
     }
     trg.options.length = 1;
     s_cnt.value = s_cnt.value - del;
     return true;
   }
}

//----------------------------------------------------------------------
// @function     selGetElement
// @desc         retorna um objeto do formulrio a partir do
//               seu caminho na rvore de objetos (document.form.field)
// @param        str       caminho do objeto
// @returns      objeto correspondente ao caminho indicado | undefined
//----------------------------------------------------------------------
function selGetElement(str) {
   return eval(str);
}

//----------------------------------------------------------------
// @function     _selAddMark
// @desc         registra a insero de um elemento se necessrio
// @param        optValue   valor inserido
//----------------------------------------------------------------
function _selAddMark(optValue) {
   if (_selFind(s_rem,optValue)) {
     var pos = s_rem.value.indexOf(optValue);
     s_rem.value = s_rem.value.substr(0,pos-1)+s_rem.value.substr(pos+optValue.length);
   }
   else {
     if (s_add.value.length > 0) {
        s_add.value = s_add.value + "#" + optValue;
     }
     else {
        s_add.value = optValue;
     }
   }
}

//---------------------------------------------------------------
// @function     _selRemoveMark
// @desc         registra a remoo de um elemento se necessrio
// @param        optValue   valor removido
//---------------------------------------------------------------
function _selRemoveMark(optValue) {
   var in_add = _selFind(s_add,optValue);
   var in_pre = _selFindPre(optValue);
   if ((in_add) && (!in_pre)) {
     var pos = s_add.value.indexOf(optValue);
     s_add.value = s_add.value.substr(0,pos-1)+s_add.value.substr(pos+optValue.length+1);
   }
   else {
     if (s_rem.value.length > 0) {
       s_rem.value = s_rem.value + "#" + optValue;
     }
     else {
       s_rem.value = optValue;
     }
   }
}

//----------------------------------------------------------
// @function     _selFind
// @desc         procura por um elemento em um campo string
// @param        field       campo a ser pesquisado
// @param        value       valor a ser procurado no campo
// @returns      true | false
//----------------------------------------------------------
function _selFind(field,value) {
   if (field.value.indexOf(value) != -1) {
     return true;
   }
   else {
     return false;
   }
}

//----------------------------------------------------------
// @function     _selFindPre
// @desc         procura por um elemento nos valores
//               pr-inseridos (vindos do banco de dados)
// @param        value       valor a ser procurado no campo
// @returns      true | false
//----------------------------------------------------------
function _selFindPre(value) {
   if (s_pre.indexOf(value) != -1) {
     return true;
   }
   else {
     return false;
   }
}