# MySQL-Front Dump 2.3
#
# Host: localhost   Database: phpscribe
#--------------------------------------------------------
# Server version 3.23.55-max-nt


#
# Table structure for table 'class'
#

DROP TABLE IF EXISTS class;
CREATE TABLE `class` (
  `cod_class` int(11) NOT NULL auto_increment,
  `cod_file` int(11) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `description` text,
  `extends` varchar(30) default NULL,
  `author` varchar(100) default NULL,
  `note` varchar(250) default NULL,
  `file_line` int(11) NOT NULL default '0',
  `revision` int(11) NOT NULL default '1',
  PRIMARY KEY  (`cod_class`),
  KEY `idx_cod_file` (`cod_file`),
  KEY `idx_revision6` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'class'
#


#
# Table structure for table 'example'
#

DROP TABLE IF EXISTS example;
CREATE TABLE `example` (
  `cod_example` int(11) NOT NULL auto_increment,
  `cod_function` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_example`),
  KEY `idx_cod_function3` (`cod_function`),
  KEY `idx_revision4` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'example'
#


#
# Table structure for table 'file'
#

DROP TABLE IF EXISTS file;
CREATE TABLE `file` (
  `cod_file` int(11) NOT NULL auto_increment,
  `cod_file_type` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `path` varchar(255) NOT NULL default '',
  `complete_path` varchar(255) NOT NULL default '',
  `extension` varchar(8) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_file`),
  UNIQUE KEY `UC_complete_path` (`complete_path`),
  KEY `idx_cod_file_type` (`cod_file_type`),
  KEY `idx_revision7` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'file'
#


#
# Table structure for table 'file_type'
#

DROP TABLE IF EXISTS file_type;
CREATE TABLE `file_type` (
  `cod_file_type` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `extension` varchar(8) NOT NULL default '',
  `language` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`cod_file_type`)
) TYPE=MyISAM;



#
# Dumping data for table 'file_type'
#
INSERT INTO file_type VALUES("1", "PHP Scripts", "php", "PHP");
INSERT INTO file_type VALUES("2", "PHP Include Files", "inc", "PHP");


#
# Table structure for table 'function'
#

DROP TABLE IF EXISTS function;
CREATE TABLE `function` (
  `cod_function` int(11) NOT NULL auto_increment,
  `cod_file` int(11) NOT NULL default '0',
  `cod_class` int(11) default NULL,
  `name` varchar(30) NOT NULL default '',
  `author` varchar(100) NOT NULL default '',
  `access` enum('public','private') default 'public',
  `description` text NOT NULL,
  `return` varchar(200) default NULL,
  `note` text NOT NULL,
  `file_line` int(11) NOT NULL default '0',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_function`),
  KEY `idx_cod_class` (`cod_class`),
  KEY `idx_cod_file2` (`cod_file`),
  KEY `idx_revision5` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'function'
#


#
# Table structure for table 'param'
#

DROP TABLE IF EXISTS param;
CREATE TABLE `param` (
  `cod_param` int(11) NOT NULL auto_increment,
  `cod_function` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `datatype` varchar(50) NOT NULL default '',
  `description` varchar(250) NOT NULL default '',
  `param_order` smallint(5) unsigned NOT NULL default '0',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_param`),
  KEY `idx_cod_function` (`cod_function`),
  KEY `idx_revision2` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'param'
#


#
# Table structure for table 'project'
#

DROP TABLE IF EXISTS project;
CREATE TABLE `project` (
  `cod_project` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `brief_description` varchar(100) NOT NULL default '',
  `description` text,
  `server_path` varchar(200) NOT NULL default '',
  `developers` varchar(200) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `website` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`cod_project`)
) TYPE=MyISAM;



#
# Dumping data for table 'project'
#


#
# Table structure for table 'property'
#

DROP TABLE IF EXISTS property;
CREATE TABLE `property` (
  `cod_property` int(11) NOT NULL auto_increment,
  `cod_class` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `datatype` varchar(50) NOT NULL default '',
  `description` text NOT NULL,
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_property`),
  KEY `idx_cod_class3` (`cod_class`),
  KEY `idx_revision8` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'property'
#


#
# Table structure for table 'revision'
#

DROP TABLE IF EXISTS revision;
CREATE TABLE `revision` (
  `cod_revision` int(11) NOT NULL auto_increment,
  `cod_project` int(11) NOT NULL default '0',
  `date_revision` date NOT NULL default '0000-00-00',
  `number_revision` varchar(10) NOT NULL default '0.0.1',
  PRIMARY KEY  (`cod_revision`),
  KEY `idx_project` (`cod_project`)
) TYPE=MyISAM;



#
# Dumping data for table 'revision'
#


#
# Table structure for table 'see'
#

DROP TABLE IF EXISTS see;
CREATE TABLE `see` (
  `cod_see` int(11) NOT NULL auto_increment,
  `cod_function` int(11) NOT NULL default '0',
  `class_name` varchar(100) default NULL,
  `function_name` varchar(100) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_see`),
  KEY `idx_cod_function2` (`cod_function`),
  KEY `idx_revision3` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'see'
#


#
# Table structure for table 'uses'
#

DROP TABLE IF EXISTS uses;
CREATE TABLE `uses` (
  `cod_use` int(11) NOT NULL auto_increment,
  `cod_class` int(11) NOT NULL default '0',
  `name_class_used` varchar(100) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_use`),
  KEY `idx_cod_class2` (`cod_class`),
  KEY `idx_revision1` (`revision`)
) TYPE=MyISAM;



#
# Dumping data for table 'uses'
#