                 <TABLE cellSpacing=0 cellPadding=10 width=564>
                   <TBODY>
                   <TR>
                     <TD>
                     <p class='bodytext'>
                     These are the help topics of phpScribe.<br><br>
                     Here you'll be able to be familiar with the comment patterns
                     of the parser and to read some tips about the process of generating
                     the documentation files to your projects.<br><br>
                     Choose a topic below:
                     </p>
                     <a href='#comment_patterns' class='normalblue'>1. Comment Patterns</a><br><br>
                     &nbsp;&nbsp;&nbsp;<a href='#comment_delimiter' class='normalblue'>1.1. General Comment Delimiter</a><br><br>
                     &nbsp;&nbsp;&nbsp;<a href='#classes_comments' class='normalblue'>1.2. Classes Comments</a><br><br>
                     &nbsp;&nbsp;&nbsp;<a href='#properties_comments' class='normalblue'>1.3. Class Properties Comments</a><br><br>
                     &nbsp;&nbsp;&nbsp;<a href='#methods_comments' class='normalblue'>1.4. Class Methods Comments</a><br><br>
                     &nbsp;&nbsp;&nbsp;<a href='#function_comments' class='normalblue'>1.5. Function Comments</a><br><br>
                     <a href='#documentation_generation' class='normalblue'>2. Documentation Generation</a><br><br>
                     </TD>
                   </TR>
                   <TR>
                     <TD CLASS='bodytext' COLSPAN='3' VALIGN='top'>
                      <a name='comment_patterns'></a>
                      <b>1. Comment Patterns</b><br><br>
                      To get your source codes documented by phpScribe, you'll have to follow some comment patterns which
                      can be understood by the parser. That pattern has to be applied when commenting classes and its properties,
                      constructor and methods and general project files and its functions.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                      <a name='comment_delimiter'></a>
                      <b>1.1. General Comment Delimiter</b><br><br>
                      Use the character sequence <code>//!</code> to start and end comment lines in <i>classes</i>, <i>methods</i> and <i>
                      functions</i>. The class properties doesn't need comment delimiters.<br>
                      The lines between the delimiters must contain <code>//</code> in the first two positions, to
                      be skipped by PHP's parser. The multiline comment <code>/* */</code> won't be understood by phpScribe's parser.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                      <a name='classes_comments'></a>
                      <b>1.2. Classes Comments</b><br><br>
                      Follow the example below to write the comment lines to your project's classes:<br><br>
                      <code>
                      //!----------------<br>
                      // @class myClass<br>
                      // @desc This class makes this and that.<br>
                      // @extends upClass<br>
                      // @uses classA<br>
                      // @uses classB<br>
                      // @author John R.<br>
                      // @note Use this class to build this and that.<br>
                      //!----------------<br>
                      </code><br>
                      The above words preceeded by '@' have the following meanings:<br><br>
                      <code>@class</code>: The class name.<br>
                      <code>@desc</code>: A brief description of the class purpose.<br>
                      <code>@extends</code>: The name of the class extended by the current class.<br>
                      P.S.: The tag '@extends' must be found only once per class. As you know, PHP doesn't support multiple heritance yet.<br>
                      <code>@uses</code>: If you crate an instance of 'classA' inside 'myClass', then myClass 'uses' classA. You can provide
                      more than one line of this type.<br>
                      <code>@author</code>: The class author.<br>
                      <code>@note</code>: Some note or advice about the class.<br>
                      P.S.: Only the tags @class and @desc are mandatory.<br>
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The '-' characters are not necessary. We put them here for stetic reasons.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                      <a name='properties_comments'></a>
                      <b>1.3. Class Properties Comments</b><br><br>
                      Each property must have, above, beside or below the real declaration, a comment line formatted like this:<br><br>
                      <code>
                      // @var myVar1 (int) this var stores the value of...<br>
                      // @var myVar2 (string) this is a string var in my class<br>
                      // @var myArray (array) this is an array<br>
                      // @var myObj (object) this is an instance of another class/object<br>
                      </code><br>
                      This order must be respected:<br>
                      a) <code>// @var</code><br>
                      b) <code>myVar</code>: property name<br>
                      c) <code>(int)</code>: data type of the property. it's optional. if a data type is provided, parenthesis are mandatory.<br>
                      d) <code>this var stores the value of...</code>: the description of the property.<br><br>
                      Between one and another element, it doesn't matter how many spaces or tabs are found. The system converts all tabs and spaces in only one space.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                      <a name='methods_comments'></a>
                      <b>1.4. Class Methods Comments</b><br><br>
                      The methods of a class must respect the following pattern:<br><br>
                      <code>
                      //!----------------<br>
                      // @function className::methodName<br>
                      // @desc This method makes this and that.<br>
                      // @access public<br>
                      // @param param1 (int) first parameter<br>
                      // @param param2 (string) second parameter<br>
                      // @see className::methodRelated<br>
                      // @author John R.<br>
                      // @note Execute the method X before this method to get the correct results.<br>
                      //!----------------<br>
                      </code><br>
                      The above words preceeded by '@' have the following meanings:<br><br>
                      <code>@function</code>: The class that contains the method and the method name, separated by <code>::</code><br>
                      <code>@desc</code>: Description of the method<br>
                      <code>@access</code>: The accepted values are 'public', 'private' and 'proteced'. This tag was created
                      just to get some compatibility with other languages as C++<br>
                      <code>@param</code>: Description of the <i>n<sup>th</sup></i> parameter, respecting the same order of the
                      class properties comment: var name, data type and description<br>
                      <code>@see</code>: Provide here the methods that are related to the current method if they deal with the same data,
                      if they execute similar functions, if they execute in a sequence or if they interchange data<br>
                      <code>@author</code>: The author of the method<br>
                      <code>@note</code>: Some advice to get the best results from the method.<br>
                      <br>
                      P.S.: In a class method, <code>@function</code> and <code>@desc</code> are mandatory.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                      <a name='function_comments'></a>
                      <b>1.5. Function Comments</b><br><br>
                      The functions located outside the project's classes must be documented like this:<br><br>
                      <code>
                      //!----------------<br>
                      // @function functionName<br>
                      // @desc This function makes this and that.<br>
                      // @param param1 (int) first parameter<br>
                      // @param param2 (string) second parameter<br>
                      // @see className::methodRelated<br>
                      // @author John R.<br>
                      // @note This function can be used to get the value of...<br>
                      //!----------------<br>
                      </code><br>
                      The above words preceeded by '@' have the following meanings:<br><br>
                      <code>@function</code>: The function name<br>
                      <code>@desc</code>: Description of the function<br>
                      <code>@param</code>: Description of the <i>n<sup>th</sup></i> parameter, respecting the same order of the
                      class properties comment: var name, data type and description<br>
                      <code>@see</code>: Provide here the functions that are related to the current function if they deal with the same data,
                      if they execute similar functions, if they execute in a sequence or if they interchange data<br>
                      <code>@author</code>: The author of the function<br>
                      <code>@note</code>: Some advice to get the best results from the method.<br>
                      <br>
                      P.S.: In a function documentation, <code>@function</code> and <code>@desc</code> are mandatory.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                      <a name='documentation_generation'></a>
                      <b>2. Generation my Project's Documentation</b><br><br>
                      If you have your project correctly documented respecting phpScribe's pattern, and your
                      document generator is working well, it's almost all done! Just create a new project in the section
                      'My Projects' and then generate its documentation. Some of the documentation parameters are described here:<br><br>
                      <b></b> <i>Skin</i>: This documentation generation system have some color schemes stored that can be applied
                      to the HTML files. Choose the color collection you like more or the one that harmonize with
                      the project's purpose or theme.<br>
                      <b></b> <i>Parse Classes Only</i>: Choose yes to skip the elements that aren't classes, class methods or properties.<br>
                      <b></b> <i>Include Private Members</i>: Choose no to hide the private methods of the classes in the documentation.<br>
                      <b></b> <i>Generation Type</i>: Choose 'Store on the Server' to write the documentation in a folder of the Web Server where
                      your phpScribe copy is running. On the other hand, choose 'Download the Files' to generate a .zip file containing the
                      documentation of your project. Download it to save it in your machine or everywhere you want.<br><br>
                      <a class='subnav' href='#top'>Back to the Top</a><br><br>
                     </TD>
                    </TR>
                    </TBODY>
                   </TABLE>